=== debian/changelog ===
ceres-solver (2.0.0+dfsg1-5) unstable; urgency=medium

  * [9a62611] One more test fix

 -- Anton Gladky <gladk@debian.org>  Wed, 15 Dec 2021 17:39:57 +0100

ceres-solver (2.0.0+dfsg1-4) unstable; urgency=medium

  * [7a12468] Change BD from node-html5shiv:native to node-html5shiv

 -- Anton Gladky <gladk@debian.org>  Tue, 14 Dec 2021 23:45:11 +0100

ceres-solver (2.0.0+dfsg1-3) unstable; urgency=medium

  * [46d1b53] Disable one more check
  * [5e891e8] Let autopkgtest write to stderr

 -- Anton Gladky <gladk@debian.org>  Tue, 14 Dec 2021 23:14:13 +0100

ceres-solver (2.0.0+dfsg1-2) unstable; urgency=medium

  * [8e9d81a] Disable one test completely.
  * [0406c95] Drop debug info for mipsel.

 -- Anton Gladky <gladk@debian.org>  Thu, 09 Dec 2021 21:52:55 +0100

ceres-solver (2.0.0+dfsg1-1) unstable; urgency=medium

  * [b95ca20] Fix Uploaders-field. (Closes: #1000231)
  * [afa5226] Disable one check failing on i386
  * Upload new version into unstable (Closes: #1001307)

 -- Anton Gladky <gladk@debian.org>  Wed, 08 Dec 2021 22:17:50 +0100

ceres-solver (2.0.0+dfsg1-1~exp1) experimental; urgency=medium

  * Team upload.

  [ Anton Gladky ]
  * [23aba26] New upstream version 2.0.0+dfsg1
  * [4417cbf] Override lintian
  * [ad4cf16] fix privacy breach
  * [486de14] Update d/copyright
  * [53ad04b] Update d/watch

  [ Francois Mazen ]
  * New upstream version.
  * Bump standard version to 4.6.0.
  * Remove patch applied upstream.
  * Mention not-needed in the Forwarded field of the patch headers.
  * Add gawk in Build-Depends to avoid virtual package dependency.
  * Add python3 shebang in docs (improve existing patch).
  * Add gawk as build dependency because awk is a virtual package.
  * Change lib package name to libceres2 from libceres1.

  [ Helmut Grohne ]
  * Move documentation dependencies to B-D-I. (Closes: #984887)

  [ Bastian Germann ]
  * [078cd9f] d/changelog: Add missing information
  * [5675e27] Try crossbuild

 -- Anton Gladky <gladk@debian.org>  Thu, 02 Dec 2021 19:52:19 +0100
