=== debian/tests/control ===
Tests: all
Depends: libceres-dev, build-essential
Restrictions: allow-stderr
